#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x26, 16, 2);

//array to store the sums
const int sPins[] = {3, 5, 6, 9};
//int to store the carry
const int c0Pin = 10;

//array to store the binary output
int binaryResult[5];

void setup() {
  lcd.init();
  lcd.backlight();
  Serial.begin(9600);
}

void loop() {

  //calling all functions
  updateBinaryResult();
  displayBinaryResult();
  displayDecimalResult();
  delay(10);
  updateBinaryResult();
}

//updating the biary result depending on the input
void updateBinaryResult() {
  for (int i = 0; i < 4; i++) {
    binaryResult[i] = digitalRead(sPins[i]);
  }
  binaryResult[4] = digitalRead(c0Pin);
}

//displaying the binary result
void displayBinaryResult() {
  lcd.setCursor(0, 0);
  lcd.print("Binary: ");
  for (int i = 4; i >= 0; i--) {
    lcd.print(binaryResult[i]);
  }
}

//displaying the decimal result
void displayDecimalResult() {
  int decimalResult = binaryToDecimal(binaryResult, 5);
  lcd.setCursor(0, 1);
  lcd.print("Decimal: ");
  lcd.print(decimalResult);
}

//converting from binary to decimal
int binaryToDecimal(int binary[], int size) {
  int decimalResult = 0;
  //looping for the size of the array, the decimal output = itself*2 + the appropirate binary element
  for (int i = size - 1; i >= 0; i--) {
    decimalResult = decimalResult * 2 + binary[i];
  }
  //returning the value
  return decimalResult;
}